SystemOrganization addCategory: #'DollarP-Core'!

RectangleMorph subclass: #DollarPMorph
	instanceVariableNames: 'recognizer points strokes currentStroke label button field lastResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DollarP-Core'!

!DollarPMorph class methodsFor: 'as yet unclassified' stamp: 'yo 8/30/2016 14:31'!
samplePicture
	| url |
	url := 'http://tinlizzie.org/~ohshima/DollarPSamples.png'.
	^( [PNGReadWriter formFromFileNamed: (url copyAfterLast: $/)]
		on: FileDoesNotExistException do: [:ex |
			| data |
			data := HTTPSocket httpGet: url.
			FileStream newFileNamed: (url copyAfterLast: $/)
				do: [:file | file binary; nextPutAll: data binary contents].
			PNGReadWriter formFromStream: data]) preMultiplyAlpha
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 16:45'!
accept: morph
	strokes size > 0 ifTrue: [
		recognizer addTemplate: strokes as: morph contents asString.
		^ true].
	^ false
! !

!DollarPMorph methodsFor: 'initialization' stamp: 'yo 8/30/2016 14:23'!
buildInputField
	^ PluggableTextMorph new
		on: self
		text: nil
		accept: #accept:
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		color: Color white;
		hideVScrollBarIndefinitely: true;
		yourself
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:33'!
button
	^ SimpleButtonMorph new
		color: (Color lightBlue);
		target: self;
		actWhen: #buttonUp;
		actionSelector: #recognize;
		setBalloonText: 'Recognize'
! !

!DollarPMorph methodsFor: 'drawing' stamp: 'yo 8/30/2016 14:25'!
drawOn: aCanvas
	| curP lastP |
	super drawOn: aCanvas.
	strokes do: [:st |
		2 to: st size do: [:i |
			lastP := st at: i - 1.
			curP := st at: i.
			aCanvas line: lastP to: curP width: 6 color: Color black]].
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:23'!
handlesMouseDown: evt
	^ true! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:23'!
handlesMouseMove: anEvent 
	^ true! !

!DollarPMorph methodsFor: 'private' stamp: 'yo 8/30/2016 14:23'!
imageMorph: aForm
	^ ImageMorph new image: aForm
! !

!DollarPMorph methodsFor: 'initialization' stamp: 'yo 8/30/2016 14:32'!
initialize
	| samplePicture sketch |
	super initialize.
	recognizer := DollarPRecognizer new.
	strokes := OrderedCollection new.
	self color: (Color gray: 0.9).
	samplePicture := self class samplePicture.
	sketch := self imageMorph: samplePicture.
	self extent: samplePicture extent * (2@1).
	self addMorph: sketch.
	sketch topLeft: 0@0.
	self addMorph: ((label := StringMorph contents: '<result>' font: (TextStyle default fontOfSize: 20) emphasis: 0) extent: 300@25).
	label position: sketch topRight.

	self addMorph: (field := self buildInputField).
	field extent: (300@25).
	field bottomRight: self bottomRight.

	self addMorph: (button := self button).
	self toggle.
! !

!DollarPMorph methodsFor: 'accessing' stamp: 'yo 8/30/2016 16:40'!
lastResult
	^ lastResult
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:27'!
mouseDown: evt
	currentStroke := OrderedCollection new.
	strokes add: currentStroke.
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:27'!
mouseMove: evt
	evt buttons = 4 ifTrue: [
		currentStroke add: evt startPoint.
		currentStroke addAll: evt trail.
	].
	self changed.
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:27'!
mouseUp: evt
	super mouseUp: evt.
	currentStroke add: evt position.
	"self recognize."! !

!DollarPMorph methodsFor: 'private' stamp: 'yo 8/30/2016 14:23'!
print3Digits: aNumber
	(aNumber respondsTo: #printShowingMaxDecimalPlaces:) ifTrue: [
		^ aNumber printShowingMaxDecimalPlaces: 3]
	ifFalse: [
		^ (aNumber truncateTo: 0.001) printString].
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:33'!
recognize
	strokes size < 1 ifTrue: [^ self].
	lastResult := recognizer recognize: strokes.
	label contents: lastResult first, ', ', (self print3Digits: lastResult second).
	strokes := OrderedCollection new.
! !

!DollarPMorph methodsFor: 'events' stamp: 'yo 8/30/2016 14:28'!
toggle
	button label: 'Recognize' font: (TextStyle default fontOfSize: 20).
	button topRight: self topRight.
! !

Object subclass: #DollarPRecognizer
	instanceVariableNames: 'templates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DollarP-Core'!

!DollarPRecognizer class methodsFor: 'all' stamp: 'yo 8/30/2016 13:45'!
new
	^ self newWith: self templateData.
! !

!DollarPRecognizer class methodsFor: 'all' stamp: 'yo 8/30/2016 13:45'!
newWith: templates
	^ super new templates: self templateData.! !

!DollarPRecognizer class methodsFor: 'all' stamp: 'yo 8/30/2016 15:28'!
templateData
	^ {
	 	{'T'.	{{30@7. 103@7}.
			 {66@7. 66@87}}}.
		{'N'. {{177@92. 177@2}.
			{182@1. 246@95}.
			{247@87. 247@1}}}.
		{'D'.	 {{345@9. 345@87}.
			 {351@8. 363@8. 372@9. 380@11. 386@14. 
			391@17. 394@22. 397@28. 399@34. 400@42. 400@50. 400@56. 399@61.
			397@66. 394@70. 391@74. 386@78. 382@81. 377@83. 372@85. 367@87. 
			360@87. 355@88. 349@87}}}.
	        {'P'. {{507@8. 507@87}.
			{513@7. 528@7. 537@8. 544@10. 550@12. 555@15. 558@18. 560@22. 561@27. 562@33. 561@37. 559@42. 556@45. 550@48. 544@51. 538@53. 532@54. 525@55. 519@55. 513@55. 510@55}}}.
		{'X'. {{30@146. 106@222}.
	       {30@225. 106@146}}}.
		{'H'. {{188@137. 188@225}.
			{188@180. 241@180}.
			{241@137. 241@225}}}.
		{'I'. {{371@149. 371@221}.
	       {341@149. 401@149}.
	       {341@221. 401@221}}}.
		{'exclamation'. {{526@142. 526@204}.
 		{526@221}}}.
		{'line'. {{12@347. 119@347}}}.
		{'five-point star'. {{177@396. 223@299. 262@396. 168@332. 278@332. 184@397}}}.
		{'null'. {{382@310. 377@308. 373@307. 366@307. 360@310. 356@313. 353@316. 349@321. 347@326. 344@331. 342@337. 341@343. 341@350. 341@358. 342@362. 344@366. 347@370. 351@374. 356@379. 361@382. 368@385. 374@387. 381@387. 390@387. 397@385. 404@382. 408@378. 412@373. 416@367. 418@361. 419@353. 418@346. 417@341. 416@336. 413@331. 410@326. 404@320. 400@317. 393@313. 392@312}.
	  {418@309. 337@390}}}.
		{'arrowhead'. {{506@349. 574@349}.
		         {525@306. 584@349. 525@388}}}.
		{'pitchfork'. {{38@470. 36@476. 36@482. 37@489. 39@496. 42@500. 46@503. 50@507. 56@509. 63@509. 70@508. 75@506. 79@503. 82@499. 85@493. 87@487. 88@480. 88@474. 87@468}.
		{62@464. 62@571}}}.
		{'six-point star'. {{177@554. 223@476. 268@554. 183@554}.
			{177@490. 223@568. 268@490. 183@490}}}.
		{'asterisk'. {{325@499. 417@557}.
			{417@499. 325@557}.
			{371@486. 371@571}}}.
		{'half-note'. {{546@465. 546@531}.
		{540@530. 536@529. 533@528. 529@529. 524@530. 520@532. 515@535. 511@539. 508@545. 506@548. 506@554. 509@558. 512@561. 517@564. 521@564. 527@563. 531@560. 535@557. 538@553. 542@548. 544@544. 546@540. 546@536}}}
}! !

!DollarPRecognizer class methodsFor: 'all' stamp: 'yo 8/30/2016 13:10'!
templates
	^ self templateData collect: [:pair | DollarPStroke new name: pair first; withPointsArray: pair second]
! !

!DollarPRecognizer methodsFor: 'all' stamp: 'yo 8/30/2016 16:41'!
addTemplate: strokes as: name
	| stroke |
	stroke := DollarPStroke new name: name; withPointsArray: strokes.
	templates := templates copyWith: stroke
! !

!DollarPRecognizer methodsFor: 'all' stamp: 'yo 8/30/2016 16:37'!
cloudDistance: ps with: ts with: n with: start
	| matched sum i more |
	matched := Array new: n withAll: false.
	sum := 0.0.
	i := start.
	more := true.
	[more] whileTrue: [
		| d index min weight |
		min := Float infinity.
		1 to: matched size do: [:j |
			(matched at: j) ifFalse: [
				d := (ps at: i) dist: (ts at: j).
				d < min ifTrue: [
					min := d.
					index := j]]]..
		matched at: index put: true.
		weight := 1.0 - ((((i - 1) - (start - 1) + n) rem: n) asFloat / n).
		sum := sum + (weight * min).
		i := (((i - 1) + 1) rem: n) + 1.
		more := i ~= start].
	^ sum.
! !

!DollarPRecognizer methodsFor: 'all' stamp: 'yo 8/30/2016 13:07'!
greedyCloudMatch: ps with: ts with: n
	| eps min step |
	eps := 0.5.
	step := (n raisedTo: (1 - eps)) floor.
	min := Float infinity.
	1 to: n by: step do: [:i |
		| d1 d2 |
		d1 := self cloudDistance: ps with: ts with: n with: i.
		d2 := self cloudDistance: ts with: ps with: n with: i.
		min := (d1 min: d2) min: min].
	^ min.
! !

!DollarPRecognizer methodsFor: 'all' stamp: 'yo 8/30/2016 15:25'!
recognize: pss
	| result stroke n score |
	n := 32.
	stroke := DollarPStroke new withPointsArray: pss.
	score := Float infinity.
	templates do: [:ts |
		| d |
		d := self greedyCloudMatch: stroke with: ts with: n.
		score > d ifTrue: [
			score := d.
			result := ts]].
	^ Array with: result name with: score.
! !

!DollarPRecognizer methodsFor: 'all' stamp: 'yo 8/30/2016 13:43'!
templates: aPairCollection
	templates := aPairCollection collect: [:pair | DollarPStroke new name: pair first; withPointsArray: pair second]
! !

Object subclass: #DollarPStroke
	instanceVariableNames: 'name points strokeID curvature isLong'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DollarP-Core'!

!DollarPStroke methodsFor: 'accessing' stamp: 'yo 8/30/2016 14:12'!
at: index
	^ points at: index
! !

!DollarPStroke methodsFor: 'future use' stamp: 'yo 8/30/2016 11:50'!
indicativeAngle: ps
	^ (ps first - ps average) theta.
! !

!DollarPStroke methodsFor: 'grail' stamp: 'yo 8/30/2016 11:50'!
isLong: ps
	| max min t end |
	max := Float infinity negated.
	min := Float infinity.

	end := ps first.
	ps size // 2 + 1 to: ps size do: [:j |
		t := ((ps at: j) - end) theta.
		t > (Float pi * 1.5) ifTrue: [t := t - (Float pi * 2)].
		max := max max: t.
		min := min min: t].
	
	end := ps last.
	1 to: ps size // 2 do: [:i |
		t := (end - (ps at: i)) theta.
		t > (Float pi * 1.5) ifTrue: [t := t - (Float pi * 2)].
		max := max max: t.
		min := min min: t].
	
	^ (max - min) < 10 degreesToRadians.
! !

!DollarPStroke methodsFor: 'grail' stamp: 'yo 8/30/2016 11:50'!
isOneDimensional
	^ isLong
! !

!DollarPStroke methodsFor: 'accessing' stamp: 'yo 8/30/2016 11:50'!
name
	^ name
! !

!DollarPStroke methodsFor: 'accessing' stamp: 'yo 8/30/2016 11:50'!
name: aString
	name := aString
! !

!DollarPStroke methodsFor: 'recognize' stamp: 'yo 8/30/2016 13:19'!
pathLength: ps
	| d |
	d := 0.0.
	2 to: ps size do: [:i | 
		(strokeID at: i) = (strokeID at: i - 1) ifTrue: [
			d := d + ((ps at: i) dist: (ps at: i - 1)).
		]
	].
	^ d.
! !

!DollarPStroke methodsFor: 'printing and debugging' stamp: 'yo 8/30/2016 14:39'!
points
	^ points
! !

!DollarPStroke methodsFor: 'initialization' stamp: 'yo 8/30/2016 13:27'!
preProcess
	points := (self resample: points with: 32) asArray.
	isLong := self isLong: points.
	points := self translate: points to: 0@0.
"	radians := self indicativeAngle: points.
	points := self rotate: points by: radians."
	points := self scale: points to: 250.


! !

!DollarPStroke methodsFor: 'printing and debugging' stamp: 'yo 8/30/2016 11:50'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPutAll: '('.
	aStream nextPutAll: (name ifNil: ['*']).
	aStream nextPutAll: ')'.
! !

!DollarPStroke methodsFor: 'recognize' stamp: 'yo 8/30/2016 13:26'!
resample: pArray with: n
	| d newPoints dd q currentP ii lastP i ps |
	ps := pArray asOrderedCollection.
	ii := (self pathLength: pArray) / (n - 1) asFloat.
	dd := 0.
	newPoints := OrderedCollection with: ps first.
	i := 2.
	[i <= ps size] whileTrue: [
		lastP := ps at: i - 1.
		currentP := ps at: i.
		(strokeID at: i - 1) = (strokeID at: i) ifTrue: [
			d := lastP dist: currentP.
			dd + d >= ii ifTrue: [
				q := lastP + (((ii - dd) / d) * (currentP - lastP)).
				newPoints add: q.
				ps add: q beforeIndex: i.
				strokeID add: (strokeID at: i - 1) beforeIndex: i.
				dd := 0]
			ifFalse: [
				dd := dd + d]].
			i := i + 1].
	newPoints size = (n - 1) ifTrue: [newPoints add: ps last].
	^ newPoints.
! !

!DollarPStroke methodsFor: 'future use' stamp: 'yo 8/30/2016 11:50'!
rotate: ps by: rad
	^ ps collect: [:p |
		| r theta |
		r := p r.
		theta := rad asFloat - p theta.
		((r * theta cos)) @  (0 - (r * theta sin))].
! !

!DollarPStroke methodsFor: 'recognize' stamp: 'yo 8/30/2016 15:27'!
scale: ps to: size
	| bbExt m |
	bbExt := (Rectangle encompassing: ps) extent.
	m := bbExt x max: bbExt y.
	^ ps collect: [:p | p * size / m].
! !

!DollarPStroke methodsFor: 'printing and debugging' stamp: 'yo 8/30/2016 14:40'!
show
	self show: points scale: 1.
! !

!DollarPStroke methodsFor: 'printing and debugging' stamp: 'yo 8/30/2016 13:28'!
show: ps scale: scale
	| c f pp |
	f := Form extent: 250@250 depth: 32.
	f fillColor: Color white.
	c := f getCanvas.
	ps do: [:p |
		pp := (p * scale) + (f extent // 2).
		c fillOval: (pp - (2@2) extent: 4@4) color: Color black borderWidth: 0 borderColor: Color transparent].
	f displayAt: 0@500
! !

!DollarPStroke methodsFor: 'recognize' stamp: 'yo 8/30/2016 11:50'!
translate: ps to: newC
	| c |
	c := ps average - newC.
	^ ps collect: [:p | p - c].
! !

!DollarPStroke methodsFor: 'initialization' stamp: 'yo 8/30/2016 13:25'!
withPointsArray: pss
	strokeID := OrderedCollection streamContents: [:stroke |
		points := Array streamContents: [:ps |
		1 to: pss size do: [:ind |
			stroke nextPutAll: (Array new: (pss at: ind) size withAll: ind).
			ps nextPutAll: (pss at: ind)]]].
	self preProcess
! !
